HDU 3535 AreYouBusy 题解(动态规划)

<a target=_blank href="http://acm.hdu.edu.cn/showproblem.php?pid=3535">http://acm.hdu.edu.cn/showproblem.php?pid=3535</a>

AreYouBusy

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2912    Accepted Submission(s): 1069


Problem Description
Happy New Term!
As having become a junior, xiaoA recognizes that there is not much time for her to AC problems, because there are some other things for her to do, which makes her nearly mad.
What's more, her boss tells her that for some sets of duties, she must choose at least one job to do, but for some sets of things, she can only choose at most one to do, which is meaningless to the boss. And for others, she can do of her will. We just define the things that she can choose as "jobs". A job takes time , and gives xiaoA some points of happiness (which means that she is always willing to do the jobs).So can you choose the best sets of them to give her the maximum points of happiness and also to be a good junior(which means that she should follow the boss's advice)?
 

Input
There are several test cases, each test case begins with two integers n and T (0<=n,T<=100) , n sets of jobs for you to choose and T minutes for her to do them. Follows are n sets of description, each of which starts with two integers m and s (0<m<=100), there are m jobs in this set , and the set type is s, (0 stands for the sets that should choose at least 1 job to do, 1 for the sets that should choose at most 1 , and 2 for the one you can choose freely).then m pairs of integers ci,gi follows (0<=ci,gi<=100), means the ith job cost ci minutes to finish and gi points of happiness can be gained by finishing it. One job can be done only once.
 

Output
One line for each test case contains the maximum points of happiness we can choose from all jobs .if she can’t finish what her boss want, just output -1 .
 

Sample Input
  
  
3 3 2 1 2 5 3 8 2 0 1 0 2 1 3 2 4 3 2 1 1 1 3 4 2 1 2 5 3 8 2 0 1 1 2 8 3 2 4 4 2 1 1 1 1 1 1 0 2 1 5 3 2 0 1 0 2 1 2 0 2 2 1 1 2 0 3 2 2 1 2 1 1 5 2 8 3 2 3 8 4 9 5 10
 

Sample Output
  
  
5 13 -1 -1
分组背包,有3种不同类型的物品组,0类型的物品组至少要选一个物品,1类型的物品组最多选一个物品,2类型的物品组物品任意选,我们用dp[ i ][ j ]表示前i个物品组,消耗时间 j 的最大快乐值,那么对于0类型的物品组:dp[ i ][ j ]=max(dp[ i-1 ][ j-ci ]+gi,dp[ i ][ j-ci ]+gi),ci,gi为第i个物品组中的物品,我们需要枚举该组的每个物品进行转移,后面的同理。对于1类型的物品组:dp[ i ][ j ]=max(dp[ i-1 ][ j ],dp[ i-1 ][ j-ci ]+gi)。对于2类型的物品:dp[ i ][ j ]=max(dp[ i-1 ][ j ],dp[ i-1 ][ j-ci ]+gi,dp[ i ][ j-ci ]+gi)。这个题还有个坑,ci和gi可以等于0,所以我要注意些细节的处理,具体见代码:

#include<stdio.h>
#include<iostream>
#include<string>
#include<string.h>
#include<vector>
#include<algorithm>
#define nn 1100
#define inff 0x3fffffff
#define mod 1000000007
using namespace std;
typedef long long LL;
int n,t;
struct node
{
    int c,g;
}ix;
int b[110];
vector<node>ve[110];
int dp[110][110];
int main()
{
    int i,m,j,k;
    while(scanf("%d%d",&n,&t)!=EOF)
    {
        for(i=1;i<=n;i++)
        {
            ve[i].clear();
            scanf("%d%d",&m,&b[i]);
            while(m--)
            {
                scanf("%d%d",&ix.c,&ix.g);
                ve[i].push_back(ix);
            }
        }
        for(i=0;i<=n;i++)
        {
            for(j=0;j<=t;j++)
                dp[i][j]=-inff;
        }
        dp[0][0]=0;
        for(i=1;i<=n;i++)
        {
            for(k=0;k<(int)ve[i].size();k++)
            {
                for(j=t;j>=0;j--)
                {
                    if(j-ve[i][k].c<0)
                        continue;
                    if(b[i]==0||b[i]==2)
                    {
                        dp[i][j]=max(dp[i][j],dp[i][j-ve[i][k].c]+ve[i][k].g);//因为有ci等于0的数据,所以这两个转移的先后顺序不能颠倒。当然也可以写几个判断来处理这种情况。
                        dp[i][j]=max(dp[i][j],dp[i-1][j-ve[i][k].c]+ve[i][k].g);
                    }
                    else if(b[i]==1)
                        dp[i][j]=max(dp[i][j],dp[i-1][j-ve[i][k].c]+ve[i][k].g);
                }
            }
            if(b[i]==2||b[i]==1)
                for(j=t;j>=0;j--)
                    dp[i][j]=max(dp[i][j],dp[i-1][j]);
        }
        int ans=-1;
        for(i=0;i<=t;i++)
            ans=max(ans,dp[n][i]);
        printf("%d\n",ans);
    }
    return 0;
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值